#ifndef VDITEMEDITOR_H
#define VDITEMEDITOR_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <windows.h>
#include <vector>
#include "VDItem.h"
#include "VDError.h"
#include "VDSprite.h"
#include "VDInput.h"
#include "Resource.h"
using namespace std;



/* **********************************************************************************************************************
   VDItemEditor
   **********************************************************************************************************************/

class VDItemEditor {
public:
    VDItemEditor();
    ~VDItemEditor();

    void FreeMemory();
    HWND Load(HINSTANCE instance, HWND parentWindow, LPCSTR className);
    void ProcessMessages(HINSTANCE instance, LPDIRECT3DDEVICE9 direct3DDevice, VDInput* input, vector<VDItem>* items);
    BOOL AddItem(vector<VDItem>* items, LPCSTR name, LPCSTR imageFileLocation);
    void WriteItems(vector<VDItem>* items);

    VDItem* GetVDItem(vector<VDItem>* items, LPCSTR name);

         HWND GetItemListBox()              { return itemListBox; }
    VDSprite* GetItemSprite()               { return itemSprite; }
       LPRECT GetItemSpriteDimensions()     { return &itemSpriteDimensions; }
         BOOL GetReloadItems()              { return reloadItems; }
         void SetReloadItems(BOOL reload)   { reloadItems = reload; }
private:
         HWND window;
         HWND itemListBox;
         char currentItemSelection[FILE_NAME_MAX_SIZE];
    VDSprite* itemSprite;
         char itemSpriteImageLocation[FILE_NAME_MAX_SIZE];
         RECT itemSpriteDimensions;
         BOOL itemSelected;
         HWND removeItemButton;
         HWND transparencyColor;
         HWND loadSpriteButton;
         HWND shiftSpriteUp;
         HWND shiftSpriteDown;
         HWND shiftSpriteLeft;
         HWND shiftSpriteRight;
         HWND nameEditBox;

         HWND itemTypeComboBox;
         char currentItemTypeSelection[FILE_NAME_MAX_SIZE];
         HWND armorLocationStatic;
         HWND armorLocationComboBox;
         HWND armorProtectionStatic;
         HWND armorProtectionComboBox;

         HWND addItemButton;
         HWND saveChangesButton;
         BOOL reloadItems;
};



#endif  // VDITEMEDITOR_H